function [Dist,Path] = findshortestpath(M,nodefrom,nodeid)

[nrow,ncol] = size(M);
Dist = 10000*ones(1,ncol);
pred = -1*ones(1,ncol);
done = zeros(1,ncol);
Path = cell(1,ncol);

Dist(nodefrom) = 0;

for i = 1:nrow
    nodeclosest = -1;
    minDist = 10000;
    for j = 1:ncol
        if ~done(j)
            if Dist(j) <= minDist
                minDist = Dist(j);
                nodeclosest = j;
            end
        end
    end
    done(nodeclosest) = 1;
    for j = 1:ncol
        if ~done(j)
            if Dist(nodeclosest)+M(nodeclosest,j) < Dist(j)
                Dist(j) = Dist(nodeclosest)+M(nodeclosest,j);
                pred(j) = nodeclosest;
            end
        end
    end
end

for j = 1:ncol
    v = j;
    if Dist(j) < 10000
        if nodefrom == j
            Path{j} = nodeid{j};
        else
            Path{j} = '';
        end
        while v > 0
            v = pred(v);
            if v >= 0
                Path{j} = char([nodeid{v} Path{j}]);
            end
        end
    end
end